//
//  GBFileItem.h
//  gBrowser
//
//  Created by Andreas Schwarz on Thu Apr 18 2002.
//  Copyright (c) 2001 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import <AASFilesystemTools/AASFilesystemTools.h>
#import "GBMarkableItemProtocol.h"

@interface GBFileItem : AASBasicInfoFileItem <GBMarkableItemProtocol> {
    /// More file info ///
    NSString *fileType;
    NSString *kind;
    
    NSImage *fileIcon;
    NSImage *genericIcon;
    char hasCustomIcon;
    
    NSString *modificationDate;
    
    NSDate *creationDate;
    NSString *creationDateString;
    
    NSString *fileSizeString;
    NSString *dataForkSizeString;
    BOOL fileSizeFound;
    unsigned long long fileSize;
    unsigned long long dataForkSize;
    
    
    NSString *resolvedFileType;
	
    char isImage;
    char isText;
    char isMovie;
    
	int imageOrientation;
    
    /// Image information ///
    NSString *dimensionsString;
    NSString *colorModelString;
    NSString *resolution;
    NSString *megapixelString;
    NSString *ICCProfile;
	double megapixels;
	NSSize dimensions;
    
    BOOL foundImageData;
    
	NSDictionary *imageProperties;
	NSMutableDictionary *marks;
}

- (NSString *)fileSizeString;
- (NSString *)dataForkSizeString;

- (NSString *)kindString;

- (NSString *)modificationDateString;
- (NSString *)creationDateString;

- (NSString *)displayNamePath;

- (NSDate *)creationDate;

- (NSString *)dimensionsString;
- (NSString *)colorModelString;
- (NSString *)resolutionString;
- (NSString *)megapixelString;
- (NSString *)ICCString;

- (NSImage *)fileIcon;
- (NSImage *)genericIcon;

- (BOOL)isImage;
- (BOOL)isMovie;
- (BOOL)isText;

- (BOOL)hasCustomIcon;

- (int)imageOrientation;

- (double)megapixels;
- (NSSize)dimensions;
- (unsigned long long)fileSize;
- (unsigned long long)dataForkSize;

- (BOOL)countOfFiles:(int *)files folders:(int *)folders total:(int *)total fileFilter:(AASFileFilter *)fileFilter directoryFilter:(AASFileFilter *)directoryFilter;




- (BOOL)setAsDesktopPicture:(NSInteger)screenNumber;



CFComparisonResult GBFileSortByFilename(const void *obj1, const void *obj2, void *context);
CFComparisonResult GBFileSortByContext(const void *obj1, const void *obj2, void *context);
CFComparisonResult GBFileSort(id obj1, id obj2, int type, int reverseSort, int folderSort);

@end








